## arb 5.3

=== Makefile ===
# =============================================================== #
#                                                                 #
#   File      : Makefile                                          #
#                                                                 #
#   Institute of Microbiology (Technical University Munich)       #
#   http://www.arb-home.de/                                       #
#                                                                 #
# =============================================================== #

# -----------------------------------------------------
# The ARB Makefile is aware of the following defines:
#
# BUILDHOST_64=0/1      1=>compile on 64 bit platform (defaults to ARB_64)
# DEVELOPER=name	special compilation (values: ANY,RELEASE,your name)
# OPENGL=0/1            whether OPENGL is available
#
# -----------------------------------------------------
# ARB Makefile and ARB source code are aware of the following defines:
#
# $(MACH)               name of the machine (LINUX,SUN4,SUN5,HP,SGI or DIGITAL; see config.makefile)
# DEBUG                 compiles the DEBUG sections
# DEBUG_GRAPHICS        all X-graphics are flushed immediately (for debugging)
# ARB_64=0/1            1=>compile 64 bit version
#
# -----------------------------------------------------
# The ARB source code is aware of the following defines:
#
# NDEBUG                doesn't compile the DEBUG sections
# DEVEL_$(DEVELOPER)    developer-dependent flag (enables you to have private sections in code)
#                       DEVELOPER='ANY' (default setting) will be ignored
#                       configurable in config.makefile
#
# -----------------------------------------------------
# Read configuration 
include config.makefile

ifeq ($(LD_LIBRARY_PATH),'')
LD_LIBRARY_PATH:=${ARBHOME}/lib
endif

FORCEMASK = umask 002

# ---------------------- [unconditionally used options]

GCC:=gcc
GPP:=g++ 
CPPreal:=cpp



# ---------------------- compiler version detection

# supported compiler versions:

ALLOWED_GCC_3xx_VERSIONS=3.2 3.3.1 3.3.3 3.3.4 3.3.5 3.3.6 3.4.0 3.4.2 3.4.3
ALLOWED_GCC_4xx_VERSIONS=\
	4.0.0 4.0.1 4.0.2 4.0.3 \
	4.1.1 4.1.2 4.1.3 \
	4.2.0 4.2.1 4.2.3 4.2.4 \
	4.3 4.3.1 4.3.2 4.3.3 \
	4.4.1 4.4.3 \

ALLOWED_GCC_VERSIONS=$(ALLOWED_GCC_3xx_VERSIONS) $(ALLOWED_GCC_4xx_VERSIONS)

GCC_VERSION_FOUND=$(shell $(GCC) -dumpversion)
GCC_VERSION_ALLOWED=$(strip $(subst ___,,$(foreach version,$(ALLOWED_GCC_VERSIONS),$(findstring ___$(version)___,___$(GCC_VERSION_FOUND)___))))

USING_GCC_3XX=$(strip $(foreach version,$(ALLOWED_GCC_3xx_VERSIONS),$(findstring $(version),$(GCC_VERSION_ALLOWED))))
USING_GCC_4XX=$(strip $(foreach version,$(ALLOWED_GCC_4xx_VERSIONS),$(findstring $(version),$(GCC_VERSION_ALLOWED))))

#---------------------- define special directories for non standard builds

ifdef DARWIN
OSX_SDK:=/Developer/SDKs/MacOSX10.5.sdk
OSX_FW:=/System/Library/Frameworks
OSX_FW_OPENGL:=$(OSX_FW)/OpenGL.framework/Versions/A/Libraries
OSX_FW_IMAGEIO:=$(OSX_FW)/ApplicationServices.framework/Versions/A/Frameworks/ImageIO.framework/Versions/A/Resources
endif

#----------------------

ifdef DARWIN
	LINK_STATIC=1# link static
else
	LINK_STATIC=0# link dynamically
endif

shared_cflags :=# flags for shared lib compilation
lflags :=# linker flags
extended_warnings :=# warning flags for C and C++-compiler
extended_cpp_warnings :=# warning flags for C++-compiler only


ifeq ($(DEBUG),0)
	dflags := -DNDEBUG# defines
	cflags := -O4# compiler flags (C and C++)
 ifndef DARWIN
	lflags += -O99 --strip-all# linker flags
 endif
endif

ifeq ($(DEBUG),1)
	dflags := -DDEBUG
	cflags := -O0 -g -g3 -ggdb -ggdb3
#	cflags := -O2 -g -g3 -ggdb -ggdb3 # use this for callgrind (force inlining)
 ifndef DARWIN
	lflags += -g
 endif

	POST_COMPILE := 2>&1 | $(ARBHOME)/SOURCE_TOOLS/postcompile.pl

# Enable several warnings
	extended_warnings     := -Wwrite-strings -Wunused -Wno-aggregate-return -Wshadow
	extended_cpp_warnings := -Wnon-virtual-dtor -Wreorder -Wpointer-arith 
 ifneq ('$(USING_GCC_3XX)','')
	extended_cpp_warnings += -Wdisabled-optimization -Wmissing-format-attribute
	extended_cpp_warnings += -Wmissing-noreturn # -Wfloat-equal 
 endif
 ifneq ('$(USING_GCC_4XX)','')
#	extended_cpp_warnings += -Wwhatever
 endif

 ifeq ($(DEBUG_GRAPHICS),1)
	dflags += -DDEBUG_GRAPHICS
 endif
endif

#---------------------- developer 

ifneq ($(DEVELOPER),ANY) # ANY=default setting (skip all developer specific code)
ifdef dflags
	dflags += -DDEVEL_$(DEVELOPER)# activate developer/release specific code
endif
endif

#---------------------- 32 or 64 bit

ifndef ARB_64
	ARB_64=0#default to 32bit
endif
ifndef BUILDHOST_64
	BUILDHOST_64:=$(ARB_64)# assume build host is same as version (see config.makefile)
endif

ifeq ($(ARB_64),1)
	dflags += -DARB_64 #-fPIC 
	lflags +=
	shared_cflags += -fPIC

	ifeq ($(BUILDHOST_64),1)
#		build 64-bit ARB version on 64-bit host
		CROSS_LIB:=# empty = autodetect below
		ifdef DARWIN
			cflags += -arch x86_64
			lflags += -arch x86_64
		endif
	else
#		build 64-bit ARB version on 32-bit host
		CROSS_LIB:=/lib64
		cflags += -m64
		lflags += -m64 -m elf_x86_64
	endif
else
	ifeq ($(BUILDHOST_64),1)
#		build 32-bit ARB version on 64-bit host
		CROSS_LIB:=# empty = autodetect below
		cflags += -m32
		lflags += -m32 -m elf_i386 
	else
#		build 32-bit ARB version on 32-bit host
		CROSS_LIB:=/lib
	endif
endif

ifeq ('$(CROSS_LIB)','')
# autodetect libdir
	ifeq ($(ARB_64),1)
		CROSS_LIB:=`(test -d /lib64 && echo lib64) || echo lib`
	else
		CROSS_LIB:=`(test -d /lib32 && echo lib32) || echo lib`
	endif
endif

#---------------------- other flags

dflags += -D$(MACH) # define machine

ifdef DARWIN
	cflags += -no-cpp-precomp 
	shared_cflags += -fno-common
else
	dflags +=  $(shell getconf LFS_CFLAGS)
endif

cflags += -pipe
cflags += -fmessage-length=0# don't wrap compiler output
cflags += -funit-at-a-time
cflags += -fPIC

#---------------------- X11 location

XHOME:=/usr/X11R6
XINCLUDES:=-I$(XHOME)/include

ifdef DARWIN
	XINCLUDES := -I/sw/include -I$(OSX_SDK)/usr/X11/include -I$(OSX_SDK)/usr/include/krb5 -I/usr/OpenMotif/include #Snow Leopard couldn't find OpenMotif
endif

ifdef DARWIN
	XLIBS := -L/usr/OpenMotif/lib -lXm -L$(XHOME)/lib -lpng -lXt -lX11 -lXext -lc -lXmu -lXi
	XLIBS += -lGLU -lGL -Wl,-dylib_file,$(OSX_FW_OPENGL)/libGL.dylib:$(OSX_FW_OPENGL)/libGL.dylib
else
	XLIBS:=-L$(XHOME)/$(CROSS_LIB) -lXm -lXpm -lXt -lXext -lX11
endif

#---------------------- open GL

ifeq ($(OPENGL),1) 
	cflags += -DARB_OPENGL # activate OPENGL code
	GL     := gl # this is the name of the OPENGL base target
	GL_LIB := -lGL -L$(ARBHOME)/GL/glAW -lglAW

 ifdef DEBIAN
	GL_LIB += -lpthread
 endif

GL_PNGLIBS := -L$(ARBHOME)/GL/glpng -lglpng_arb -lpng

 ifdef DARWIN
	GLEWLIB := -L/usr/lib -lGLEW -L$(OSX_SDK)/usr/X11/lib -lGLw
	GLUTLIB := -L$(XHOME)/lib -lglut
 else 
	GLEWLIB := -lGLEW -lGLw
	GLUTLIB := -lglut
 endif

GL_LIBS := $(GL_LIB) $(GLEWLIB) $(GLUTLIB) $(GL_PNGLIBS)

#XLIBS += $(GL_LIB)

else
# OPENGL=0

GL_LIBS:=# no opengl -> no libs
GL:=# don't build ARB openGL libs

endif

#---------------------- tiff lib:

ifdef DARWIN
	TIFFLIBS := -L/usr/local/lib -ltiff -L$(OSX_FW_IMAGEIO) -lTIFF  
else
	TIFFLIBS := -ltiff
endif

#---------------------- basic libs:

SYSLIBS:=

ifdef DARWIN
	SYSLIBS += -lstdc++
else
	SYSLIBS += -lm
endif

#---------------------- include symbols?

ifeq ($(TRACESYM),1)
	ifdef DARWIN
		cdynamic =
		ldynamic =
	else
		cdynamic = -rdynamic
		ldynamic = --export-dynamic 
	endif
endif

# ------------------------------------------------------------------------- 
#	Don't put any machine/version/etc conditionals below!
#	(instead define variables above)
# -------------------------------------------------------------------------

cflags += -W -Wall $(dflags) $(extended_warnings) $(cdynamic)

cppflags := $(extended_cpp_warnings)

ifeq ($(DEVELOPER),RALF)
HAVE_GNUPP0X=`SOURCE_TOOLS/requireVersion.pl 4.3 $(GCC_VERSION_FOUND)`
ifeq ($(HAVE_GNUPP0X),1)
# ensure compatibility with upcoming C++ standard
cppflags += -std=gnu++0x
endif
endif

# compiler settings:

ACC := $(GCC)# compile C
CPP := $(GPP) $(cppflags)# compile C++
ACCLIB := $(ACC) $(shared_cflags)# compile C (shared libs)
CPPLIB := $(CPP) $(shared_cflags)# compile C++ (shared libs)

PP := $(CPPreal)# preprocessor

lflags += $(ldynamic)

LINK_STATIC_LIB := ld $(lflags) -r -o# link static lib
LINK_EXECUTABLE := $(GPP) $(lflags) $(cdynamic) -o# link executable (c++)

ifeq ($(LINK_STATIC),1)
SHARED_LIB_SUFFIX = a# static lib suffix
LINK_SHARED_LIB := $(LINK_STATIC_LIB)
else
SHARED_LIB_SUFFIX = so# shared lib suffix
LINK_SHARED_LIB := $(GPP) $(lflags) -shared -o# link shared lib
endif

# other used tools

CTAGS := etags
ifdef DARWIN
	XMKMF := /usr/X11/bin/xmkmf
else
	XMKMF := /usr/bin/X11/xmkmf
endif
MAKEDEPEND_PLAIN = makedepend

MAKEDEPEND = $(FORCEMASK);$(MAKEDEPEND_PLAIN)

SEP:=--------------------------------------------------------------------------------

# delete variables unused below

lflags:=

# ------------------------- 
#     Main arb targets:     
# ------------------------- 

first_target:
		$(MAKE) checks
		@echo $(SEP)
		@echo 'Main targets:'
		@echo ''
		@echo ' all         - Compile ARB + TOOLs + and copy shared libs + link foreign software'
		@echo '               (That is most likely the target you want)'
		@echo ''
		@echo ' clean       - remove generated files ("SUBDIR/SUBDIR.clean" to clean only SUBDIR)'
		@echo ' rebuild     - clean + all'
		@echo ' relink      - remove all binaries and relink them from objects'
		@echo ''
		@echo 'Some often used sub targets (make all makes them all):'
		@echo ''
		@echo ' arb         - Just compile ARB (but none of the integrated tools)'
		@echo ' menus       - create GDEHELP/ARB_GDEmenus from GDEHELP/ARB_GDEmenus.source'
		@echo ' perl        - Compile the PERL XSUBS into lib/ARB.so  and create links in lib to perl'
		@echo ' binlink     - Create all links in the bin directory'
		@echo ''
		@echo 'Development targets:'
		@echo ''
		@echo ' depends      - create or update dependencies ("SUBDIR/SUBDIR.depends" to update only SUBDIR)'
		@echo ' proto        - create or update prototypes ("SUBDIR/SUBDIR.proto" to update only SUBDIR)'
		@echo ' tags         - create tags for xemacs'
		@echo ' rmbak        - remove all "*%" and cores'
		@echo ' show         - show available shortcuts (AKA subtargets)'
		@echo ' up           - shortcut for depends+proto+tags'
		@echo ' modified     - rebuild files modified in svn checkout (touches files!)'
		@echo ''
		@echo 'Internal maintenance:'
		@echo ''
		@echo ' rel_minor   - build a release (increases minor version number)'
		@echo ' rel_major   - build a release (increases MAJOR version number)'
		@echo ' tarfile     - make rebuild and create arb version tarfile ("tarfile_quick" to skip rebuild)'
		@echo ' save        - save all basic ARB sources into arbsrc_DATE'
		@echo ' rtc_patch   - create LIBLINK/libRTC8M.so (SOLARIS ONLY)'
		@echo ' source_doc  - create doxygen documentation'
		@echo ' relocated   - rebuild partly (use when you have relocated ARBHOME)'
		@echo ' check_res   - check ressource usage'
		@echo ''
		@echo $(SEP)
		@echo ''


# auto-generate config.makefile:

CONFIG_MAKEFILE_FOUND=$(wildcard config.makefile)

config.makefile : config.makefile.template
		@echo --------------------------------------------------------------------------------
ifeq ($(strip $(CONFIG_MAKEFILE_FOUND)),)
		@cp $< $@
		@echo '$(ARBHOME)/$@:1: has been generated.'
		@echo 'Please edit $@ to configure your system!'
		@echo --------------------------------------------------------------------------------
		@false
else
		@echo '$(ARBHOME)/$<:1: is more recent than'
		@echo '$(ARBHOME)/$@:1:'
		@ls -al config.makefile*
		@echo --------------------------------------------------------------------------------
		@echo "Updating $@ (if this fails, check manually)"
		SOURCE_TOOLS/update_config_makefile.pl
		@echo "Sucessfully updated $@"

=== AISC/Makefile ===
# INCLUDE und GLOBALS MAIN CC cflags werden von aussen uebergeben

.SUFFIXES: .o .c .depend
OBJECTS = aisc.o aisc_commands.o aisc_var_ref.o aisc_mix.o

BINARY=aisc

$(MAIN): $(BINARY)

$(BINARY):	$(OBJECTS)
	$(CPP) $(cflags) -o $@ $(OBJECTS)

.c.o:
	$(CPP) $(cflags) -c $< $(AINCLUDES)

DEPENDS = $(OBJECTS:.o=.depend)
depends: $(DEPENDS)
	@cat $(DEPENDS) | grep -v '^#' >>Makefile
	@rm $(DEPENDS)
$(DEPENDS): depend.init
depend.init:
	$(MAKEDEPEND) $(MAKEDEPENDFLAGS) 2>/dev/null # remove dependencies
.c.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@

clean:
	rm -f $(OBJECTS) $(BINARY)

proto:
	../AISC_MKPTPS/aisc_mkpt -C -G -w aisc_proto.h *.c >aisc_proto.h.tmp
	../SOURCE_TOOLS/mv_if_diff aisc_proto.h.tmp aisc_proto.h

# DO NOT DELETE THIS LINE -- make depend depends on it.

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl

aisc.o: aisc.h
aisc.o: aisc_proto.h
aisc.o: $(ARBHOME)/INCLUDE/attributes.h

aisc_commands.o: aisc.h
aisc_commands.o: aisc_proto.h
aisc_commands.o: $(ARBHOME)/INCLUDE/attributes.h

aisc_mix.o: aisc.h
aisc_mix.o: aisc_proto.h
aisc_mix.o: $(ARBHOME)/INCLUDE/attributes.h

aisc_var_ref.o: aisc.h
aisc_var_ref.o: aisc_proto.h
aisc_var_ref.o: $(ARBHOME)/INCLUDE/attributes.h

=== AWTC/Makefile ===
# INCLUDE und GLOBALS MAIN CC cflags werden von aussen uebergeben
.SUFFIXES: .o .cxx .depend

CPP_OBJECTS = $(subst .cxx,.o,$(wildcard *.cxx))

$(MAIN): $(CPP_OBJECTS)
	$(LINK_STATIC_LIB) $(MAIN) $(CPP_OBJECTS)
.cxx.o:
	$(CPP) $(cflags) -c $<  $(CPPINCLUDES)

clean:
	rm -f $(CPP_OBJECTS) *.a

DEPENDS = $(CPP_OBJECTS:.o=.depend)
depends: $(DEPENDS)
	@cat $(DEPENDS) | grep -v '^#' >>Makefile
	@rm $(DEPENDS)
$(DEPENDS): depend.init
depend.init:
	$(MAKEDEPEND) $(MAKEDEPENDFLAGS) 2>/dev/null # remove dependencies
.c.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@
.cxx.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@

# DO NOT DELETE THIS LINE -- make depend depends on it.

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl

AWTC_constructSequence.o: awtc_constructSequence.hxx
AWTC_constructSequence.o: awtc_seq_search.hxx
AWTC_constructSequence.o: $(ARBHOME)/INCLUDE/ad_k_prot.h
AWTC_constructSequence.o: $(ARBHOME)/INCLUDE/ad_prot.h
AWTC_constructSequence.o: $(ARBHOME)/INCLUDE/ad_t_prot.h
AWTC_constructSequence.o: $(ARBHOME)/INCLUDE/arb_assert.h
AWTC_constructSequence.o: $(ARBHOME)/INCLUDE/arbdb.h
AWTC_constructSequence.o: $(ARBHOME)/INCLUDE/arbdb_base.h
AWTC_constructSequence.o: $(ARBHOME)/INCLUDE/arbdbt.h
AWTC_constructSequence.o: $(ARBHOME)/INCLUDE/attributes.h
AWTC_constructSequence.o: $(ARBHOME)/INCLUDE/aw_device.hxx
AWTC_constructSequence.o: $(ARBHOME)/INCLUDE/aw_keysym.hxx
AWTC_constructSequence.o: $(ARBHOME)/INCLUDE/aw_position.hxx
AWTC_constructSequence.o: $(ARBHOME)/INCLUDE/aw_root.hxx
AWTC_constructSequence.o: $(ARBHOME)/INCLUDE/aw_window.hxx

AWTC_next_neighbours.o: awtc_next_neighbours.hxx
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/ad_k_prot.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/ad_prot.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/ad_t_prot.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/arb_assert.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/arbdb.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/arbdb_base.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/arbdbt.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/attributes.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/aw_device.hxx
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/aw_keysym.hxx
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/aw_position.hxx
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/aw_root.hxx
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/aw_window.hxx
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/client.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/PT_com.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/servercntrl.h

AWTC_seq_search.o: awtc_seq_search.hxx
AWTC_seq_search.o: $(ARBHOME)/INCLUDE/ad_k_prot.h
AWTC_seq_search.o: $(ARBHOME)/INCLUDE/ad_prot.h
AWTC_seq_search.o: $(ARBHOME)/INCLUDE/arb_assert.h
AWTC_seq_search.o: $(ARBHOME)/INCLUDE/arbdb.h
AWTC_seq_search.o: $(ARBHOME)/INCLUDE/arbdb_base.h
AWTC_seq_search.o: $(ARBHOME)/INCLUDE/attributes.h
AWTC_seq_search.o: $(ARBHOME)/INCLUDE/aw_root.hxx

AWTC_submission.o: $(ARBHOME)/INCLUDE/ad_k_prot.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/ad_prot.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/ad_t_prot.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/arb_assert.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/arbdb.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/arbdb_base.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/arbdbt.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/attributes.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/aw_awars.hxx
AWTC_submission.o: $(ARBHOME)/INCLUDE/aw_device.hxx
AWTC_submission.o: $(ARBHOME)/INCLUDE/aw_keysym.hxx
AWTC_submission.o: $(ARBHOME)/INCLUDE/aw_position.hxx
AWTC_submission.o: $(ARBHOME)/INCLUDE/aw_root.hxx
AWTC_submission.o: $(ARBHOME)/INCLUDE/aw_window.hxx
AWTC_submission.o: $(ARBHOME)/INCLUDE/awt.hxx

=== CONVERTALN/Makefile ===
OBJECT=  main.o fconv.o mg.o genbank.o macke.o phylip.o paup.o \
	util.o date.o embl.o gcg.o printable.o alma.o \
	routines.o convert.o

.SUFFIXES: .o .c .cxx .depend

BINARY=$(ARBHOME)/bin/arb_convert_aln

$(BINARY): $(OBJECT)
	$(LINK_EXECUTABLE) $@ $(OBJECT) ../SL/FILE_BUFFER/FILE_BUFFER.a $(LIBPATH) -lARBDB

.c.o:
	$(ACC) $(cflags) -Wstrict-prototypes -c $< $(AINCLUDES) $(POST_COMPILE)

proto:
	../MAKEBIN/aisc_mkpt -C -w prototypes.h $(OBJECT:.o=.c) >prototypes.h.tmp
	../SOURCE_TOOLS/mv_if_diff prototypes.h.tmp prototypes.h

clean:
	rm -f $(OBJECT) $(BINARY)

#depend:
#	$(MAKEDEPEND) $(OBJECT:.o=.c*)

DEPENDS = $(OBJECT:.o=.depend)
depends: $(DEPENDS)
	@cat $(DEPENDS) | grep -v '^#' >>Makefile
	@rm $(DEPENDS)
$(DEPENDS): depend.init
depend.init:
	$(MAKEDEPEND) $(MAKEDEPENDFLAGS) 2>/dev/null # remove dependencies
.c.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@
.cxx.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@

# DO NOT DELETE THIS LINE -- make depend depends on it.

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl

alma.o: convert.h
alma.o: global.h
alma.o: prototypes.h
alma.o: $(ARBHOME)/INCLUDE/FileBuffer.h

convert.o: convert.h
convert.o: global.h
convert.o: prototypes.h
convert.o: $(ARBHOME)/INCLUDE/FileBuffer.h

date.o: convert.h
date.o: global.h
date.o: prototypes.h
date.o: $(ARBHOME)/INCLUDE/FileBuffer.h

embl.o: convert.h
embl.o: global.h
embl.o: prototypes.h
embl.o: $(ARBHOME)/INCLUDE/FileBuffer.h

fconv.o: convert.h
fconv.o: global.h
fconv.o: prototypes.h
fconv.o: $(ARBHOME)/INCLUDE/FileBuffer.h

gcg.o: convert.h
gcg.o: global.h
gcg.o: prototypes.h
gcg.o: $(ARBHOME)/INCLUDE/FileBuffer.h

genbank.o: convert.h
genbank.o: global.h
genbank.o: prototypes.h
genbank.o: $(ARBHOME)/INCLUDE/FileBuffer.h

macke.o: convert.h
macke.o: global.h
macke.o: prototypes.h
macke.o: $(ARBHOME)/INCLUDE/FileBuffer.h

main.o: convert.h
main.o: global.h
main.o: prototypes.h
main.o: $(ARBHOME)/INCLUDE/FileBuffer.h

mg.o: convert.h
mg.o: global.h
mg.o: prototypes.h
mg.o: $(ARBHOME)/INCLUDE/FileBuffer.h

paup.o: convert.h
paup.o: global.h
paup.o: prototypes.h
paup.o: $(ARBHOME)/INCLUDE/FileBuffer.h

phylip.o: convert.h
phylip.o: global.h
phylip.o: prototypes.h
phylip.o: $(ARBHOME)/INCLUDE/FileBuffer.h

printable.o: convert.h
printable.o: global.h
printable.o: prototypes.h
printable.o: $(ARBHOME)/INCLUDE/FileBuffer.h

routines.o: convert.h
routines.o: global.h
routines.o: prototypes.h
routines.o: $(ARBHOME)/INCLUDE/FileBuffer.h

util.o: convert.h
util.o: global.h
util.o: prototypes.h
util.o: $(ARBHOME)/INCLUDE/FileBuffer.h

=== EISPACK/Makefile ===
# INCLUDE und GLOBALS MAIN CC cflags werden von aussen uebergeben

.SUFFIXES: .o .cxx .depend


CPP_OBJECTS =  eispack.o d_sign.o

$(MAIN): $(CPP_OBJECTS)
	$(LINK_STATIC_LIB) $(MAIN) $(CPP_OBJECTS)

clean:
	rm -f $(CPP_OBJECTS) *.a

.cxx.o:
	$(CPP) $(cflags) -c $< $(CPPINCLUDES)

DEPENDS = $(CPP_OBJECTS:.o=.depend)
depends: $(DEPENDS)
	@cat $(DEPENDS) | grep -v '^#' >>Makefile
	@rm $(DEPENDS)
$(DEPENDS): depend.init
depend.init:
	$(MAKEDEPEND) $(MAKEDEPENDFLAGS) 2>/dev/null # remove dependencies
.c.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@
.cxx.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@

# DO NOT DELETE THIS LINE -- make depend depends on it.

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl

d_sign.o: f2c.h

eispack.o: f2c.h

=== GDEHELP/Makefile ===

TARGET = ARB_GDEmenus
SOURCE = ARB_GDEmenus.source
HELPFILELIST=helpfiles.lst
GENHELPDEST=./HELP_GEN
GENDOCDEST=./HELP_DOC_GEN

MENUS=$(wildcard MENUS/*.menu)
GENMENUS=$(MENUS:.menu=.genmenu)

all: $(TARGET) help

MENUS/%.genmenu : genmenu.header

MENUS/%.genmenu : MENUS/%.menu
		( cat genmenu.header; sed -e "s/^[ ]*//" ) < $< > $@

$(TARGET) : $(SOURCE) $(GENMENUS)
	-chmod a+w $(TARGET)
	$(PP)  -IMENUS $(SOURCE) >$(TARGET)
	chmod a-w $(TARGET)

# ------------------------------------------------------------

help: $(HELPFILELIST)
	@test -d $(GENHELPDEST) || mkdir $(GENHELPDEST)
	@test -d $(GENDOCDEST) || mkdir $(GENDOCDEST)
	@$(MAKE) -f Makefile.helpfiles "GENHELPDEST=$(GENHELPDEST)" "GENDOCDEST=$(GENDOCDEST)" "HELPFILELIST=$(HELPFILELIST)"

$(HELPFILELIST): $(TARGET)
	grep -i '^itemhelp:' < $< | sed -e 's/^itemhelp://' | sort | uniq > $@

# ------------------------------------------------------------

save:
	rm -f arbgdemenus*.tar.gz
	tar cvf - MENUS ARB_GDEmenus* |gzip >`date '+arbgdemnus_%d_%m_%y.tar.gz'`

clean:
	rm -f $(GENMENUS) $(TARGET) $(HELPFILELIST)
	@$(MAKE) -f Makefile.helpfiles \
		"GENHELPDEST=$(GENHELPDEST)" \
		"GENDOCDEST=$(GENDOCDEST)" \
		"HELPFILELIST=$(HELPFILELIST)" \
		clean

=== GL/Makefile ===

ARCHS_ALL = \
	glpng/libglpng_arb.dummy  \
	glAW/libglAW.dummy  \

# --------------------------------------------------------------------------------
# If a package is available as debian package it should go here

ARCHS_NON_DEBIAN = \

# --------------------------------------------------------------------------------

ifdef DEBIAN
ARCHS = $(ARCHS_ALL) 
else
ARCHS = $(ARCHS_ALL) $(ARCHS_NON_DEBIAN)
endif

# --------------------------------------------------------------------------------
# warnings in this subtree?

RAISE_WARNINGS=1

ifeq ($(RAISE_WARNINGS),0)
CPP:=$(CPP:-W -Wall=-w)
ACC:=$(ACC:-W -Wall=-w)
endif

include $(ARBHOME)/SOURCE_TOOLS/export2sub

# --------------------------------------------------------------------------------

$(MAIN): $(ARCHS)

depends: $(ARCHS:.dummy=.depend)

clean: $(ARCHS:.dummy=.clean)

%.depend:
	@cp -p $(@D)/Makefile $(@D)/Makefile.old # save old Makefile
	@$(MAKE) -C $(@D) -r depends
	@grep "^# DO NOT DELETE" $(@D)/Makefile >/dev/null # check whether sub Makefile has dependencies
	@cat $(@D)/Makefile \
		| ../SOURCE_TOOLS/fix_depends.pl \
		>$(@D)/Makefile.2
	@mv $(@D)/Makefile.old $(@D)/Makefile # restore old Makefile
	@$(ARBHOME)/SOURCE_TOOLS/mv_if_diff $(@D)/Makefile.2 $(@D)/Makefile # update Makefile if changed

%.dummy:
	@$(MAKE) -C $(@D) -r \
		"ARB  = yes" \
		"MAIN = $(@F:.dummy=.a)" \
		"cflags = $(cflags) -DIN_ARB_$(@D:/=)" \

%.clean:
	@$(MAKE) -C $(@D) \
		clean

# DO NOT DELETE

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl

=== NAMES_COM/Makefile ===
# The file, where all structures are described
MAIN_SOURCE = names.aisc

# Your own server functions
PRIVATE_SERVER_OBJECTS = names_extern.o

# Public server/client sources (needed for dependencies)
PUBLIC_SOURCES = $(wildcard C/*.c)

# Do you want to create save and load
AISC_SAVE = YES

# C++ Compiler
COMPILER = $(CPP) $(cflags) -I$(ARBHOME)/INCLUDE
CLIENTCOMPILER = $(COMPILER)

# AISC dependencies
AISC_COMPILER=../MAKEBIN/aisc
AISC_DEPENDS = $(wildcard AISC/*.pa) $(AISC_COMPILER)

include AISC/export2sub

server.a: $(MAIN_SOURCE) $(PRIVATE_SERVER_OBJECTS:.o=.c) $(PUBLIC_SOURCES) $(AISC_DEPENDS)
	@$(MAKE) -r -f AISC/Makefile

depends:
	@$(MAKE) -r -f AISC/Makefile pregenerate

clean:
	@$(MAKE) -r -f AISC/Makefile clean

# DO NOT DELETE

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl

=== PROBE_COM/Makefile ===
# The file, where all structures are described
MAIN_SOURCE := PT.aisc

# Your own server functions
PRIVATE_SERVER_OBJECTS := PT_extern.o

# Public server/client sources (needed for dependencies)
PUBLIC_SOURCES := $(wildcard C/*.c)

# Do you want to create save and load
AISC_SAVE := NO

# C++ Compiler
COMPILER := $(CPP) $(cflags) -I$(ARBHOME)/INCLUDE
CLIENTCOMPILER := $(COMPILER)

# AISC dependencies
AISC_COMPILER=../MAKEBIN/aisc
AISC_DEPENDS = $(wildcard AISC/*.pa) $(AISC_COMPILER)

include AISC/export2sub

server.a:	$(MAIN_SOURCE)	$(PRIVATE_SERVER_OBJECTS:.o=.c) $(PUBLIC_SOURCES) $(AISC_DEPENDS)
		@$(MAKE) -r -f AISC/Makefile

depends:
		@$(MAKE) -r -f AISC/Makefile pregenerate

clean:
		@$(MAKE) -r -f AISC/Makefile clean

# DO NOT DELETE

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl

=== WETC/Makefile ===
# INCLUDE und GLOBALS MAIN CC cflags werden von aussen uebergeben

.SUFFIXES: .o .cxx .depend

CPP_OBJECTS = WETC_main.o

$(MAIN): $(CPP_OBJECTS)
	$(LINK_STATIC_LIB) $(MAIN) $(CPP_OBJECTS)

.cxx.o:
	$(CPP) $(cflags) -c -o $@ $(@:.o=.cxx)  $(CPPINCLUDES)

clean:
	rm -f $(CPP_OBJECTS) *.a

DEPENDS = $(CPP_OBJECTS:.o=.depend)
depends: $(DEPENDS)
	@cat $(DEPENDS) | grep -v '^#' >>Makefile
	@rm $(DEPENDS)
$(DEPENDS): depend.init
depend.init:
	$(MAKEDEPEND) $(MAKEDEPENDFLAGS) 2>/dev/null # remove dependencies
.c.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@
.cxx.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@

# DO NOT DELETE THIS LINE -- make depend depends on it.

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl

WETC_main.o: $(ARBHOME)/INCLUDE/ad_k_prot.h
WETC_main.o: $(ARBHOME)/INCLUDE/ad_prot.h
WETC_main.o: $(ARBHOME)/INCLUDE/arb_assert.h
WETC_main.o: $(ARBHOME)/INCLUDE/arbdb.h
WETC_main.o: $(ARBHOME)/INCLUDE/arbdb_base.h
WETC_main.o: $(ARBHOME)/INCLUDE/attributes.h
WETC_main.o: $(ARBHOME)/INCLUDE/aw_device.hxx
WETC_main.o: $(ARBHOME)/INCLUDE/aw_keysym.hxx
WETC_main.o: $(ARBHOME)/INCLUDE/aw_position.hxx
WETC_main.o: $(ARBHOME)/INCLUDE/aw_root.hxx
WETC_main.o: $(ARBHOME)/INCLUDE/aw_window.hxx
WETC_main.o: $(ARBHOME)/INCLUDE/awt.hxx

=== GDE/AxML/Makefile ===
# Makefile February 2002 by Alexandros P. Stamatakis

.SUFFIXES: .o .c .h .depend

OBJECTS = axml.o
RM 	   = rm -f

# ----------------------------------------
# normal compilation:
ifndef ARB

CC 		= gcc
CFLAGS 	= -O3
TARGET  = axml
MAIN 	= $(EXE)
#-xO5
# -pg
LDFLAGS = -lm

# ----------------------------------------
# compile for ARB:
else

CC      = $(ACC)
TARGET 	= $(ARBHOME)/bin/axml
LDFLAGS = -lm
CFLAGS  = $(cflags)

$(MAIN) : all

endif

all : $(TARGET)

$(TARGET) : $(OBJECTS)
	$(CC) $(CFLAGS) -o $@ $< $(LDFLAGS)

.c.o:
	$(CC) $(CFLAGS) -c -o $@ $<

clean :
	$(RM) $(OBJECTS) $(TARGET)

DEPENDS = $(OBJECTS:.o=.depend)
depends: $(DEPENDS)
	@cat $(DEPENDS) | grep -v '^#' >>Makefile
	@rm $(DEPENDS)
$(DEPENDS): depend.init
depend.init:
	$(MAKEDEPEND) $(MAKEDEPENDFLAGS) 2>/dev/null # remove dependencies
.c.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@

# DO NOT DELETE

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl

axml.o: axml.h

=== GDE/PHYML/Makefile ===
# PHYML 2.4.5 Makefile
# modified for ARB by Ralf Westram (Jun 2006)

.SUFFIXES: .o .c .h .depend

LIBS  = -lm
PROG  = PHYML
DFLAG = -DUNIX -D$(PROG)
OBJS  = main.o utilities.o optimiz.o lk.o bionj.o models.o free.o options.o simu.o eigen.o

ifndef ARB
# ----------------------------------------
# original compilation

CC = gcc #cc
CFLAGS = -O4 -fomit-frame-pointer -Wall -static
# CFLAGS = -Wall
# CFLAGS = -g -Wall
# CFLAGS = -pg -Wall -fprofile-arcs -static

EXEC = phyml 

else
# ----------------------------------------
# compilation together with ARB

CC     = $(ACC)
CFLAGS = $(cflags) -fomit-frame-pointer
EXEC   = $(ARBHOME)/bin/phyml

ifdef DARWIN
CFLAGS += -fPIC
else
CFLAGS += -static
endif

# ARBs standard target
$(MAIN) : $(EXEC)

endif

$(EXEC) : $(OBJS)
		$(CC) -o $(EXEC) $(OBJS) $(LIBS) $(CFLAGS)

clean :
		rm -f $(OBJS) $(EXEC)

.c.o:
		$(CC) $(CFLAGS) $(DFLAG) -c -o $@ $<

######################################################################################################

DEPENDS = $(OBJS:.o=.depend)
depends: $(DEPENDS)
	@cat $(DEPENDS) | grep -v '^#' >>Makefile
	@rm $(DEPENDS)
$(DEPENDS): depend.init
depend.init:
	$(MAKEDEPEND) $(MAKEDEPENDFLAGS) 2>/dev/null # remove dependencies
.c.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@

# DO NOT DELETE

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl

bionj.o: bionj.h
bionj.o: optimiz.h
bionj.o: utilities.h

eigen.o: eigen.h
eigen.o: utilities.h

free.o: free.h
free.o: utilities.h

lk.o: free.h
lk.o: lk.h
lk.o: models.h
lk.o: optimiz.h
lk.o: utilities.h

main.o: bionj.h
main.o: free.h
main.o: lk.h
main.o: models.h
main.o: optimiz.h
main.o: options.h
main.o: simu.h
main.o: utilities.h

models.o: eigen.h
models.o: free.h
models.o: models.h
models.o: utilities.h

optimiz.o: free.h
optimiz.o: lk.h
optimiz.o: optimiz.h
optimiz.o: utilities.h

options.o: free.h
options.o: models.h
options.o: options.h
options.o: utilities.h

simu.o: free.h
simu.o: lk.h
simu.o: models.h
simu.o: optimiz.h
simu.o: simu.h
simu.o: utilities.h

utilities.o: bionj.h
utilities.o: free.h
utilities.o: lk.h
utilities.o: models.h
utilities.o: optimiz.h
utilities.o: simu.h
utilities.o: utilities.h

=== debian/changelog ===
arb (5.3-4ubuntu2) quantal; urgency=low

  * Fix build failure on ARM.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 13 Oct 2012 16:24:57 +0200

arb (5.3-4ubuntu1) quantal; urgency=low

  * Transition to libglew-dev (1.8)

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Sun, 09 Sep 2012 01:22:54 +0100

arb (5.3-4) unstable; urgency=low

  * debian/upstream: Add citations
  * debian/control:
     - Build-Depends: libpng-dev instead of libpng12-dev
       Closes: #662270
     - Standards-Version: 3.9.3 (no changes needed)
  * debian/po/nl.po: Add Dutch translation of debconf templates
    Thanks for the translation to Jeroen Schot <schot@A-Eskwadraat.nl>
    Closes: #654763
  * debian/patches/30_Makefile_main:
     - Enable gcc-4.7 as well
       Closes: #682404
     - Enable using hardening flags
  * debian/patches/gcc-4.7.patch: Fix gcc-4.7 build issue
  * debhelper 9 (control+compat)
  * debian/rules:
     - Fixed clean target
     - propagate hardening flags

 -- Andreas Tille <tille@debian.org>  Thu, 26 Jul 2012 12:15:21 +0200

arb (5.3-3) unstable; urgency=low

  * debian/control:
     - Build-Depends: time 
       Strangely enough this is not needed in local pbnuilder/sbuild
       environments but on autobuilders this seems to be a problem
       according to comparing the build logs
     - Build-Depends: libbio-perl-perl
       Otherwise some not-critical checks will fail
  * debian/arb.prerm: Care for removal of conffile link created in postinst
    Closes: #656035
  * debian/rules:
     - clean up some manual handling of files and dirs which is not
       needed any more with recent versions
     - insert check which verifies that binary-indep target is really
       builded and changed files and dirs are previousely created
       Closes: #658691

 -- Andreas Tille <tille@debian.org>  Thu, 09 Feb 2012 13:44:22 +0100

arb (5.3-2) unstable; urgency=low

  * debian/arb.README.Debian: Dropped molphy related notice
  * debian/control:
    - Remove Build-Depends: x11proto-print-dev
    - Remove at least explicite Build-Depends: libxp-dev
      Closes: #623638
  * debian/{control,rules}: Remove quilt which is unneeded when
    using source format 3.0 (quilt)
  * debian/po/ca.po: Catalan translation (thanks to Innocent De Marchi
    <tangram.peces@gmail.com>)
    Closes: #632206

 -- Andreas Tille <tille@debian.org>  Thu, 15 Dec 2011 17:00:46 +0100

arb (5.3-1) unstable; urgency=low

  [ Nelson A. de Oliveira ]
  * Fix FTBFS: replaced sablotron by xsltproc in debian/control
    (Closes: #634999)
  * Replaced arb dependency on the ssh metapackage by openssh-client only

  [ Andreas Tille ]
  * New upstream version (including updateing debian/patches/*)
    This version doese not depend from molphy any more
  * debian/control
    - Do not depend from molphy which is removed from Debian any more
    - Standards-Version: 3.9.2 (no changes needed)
    - Fixed Vcs fields
  * Debhelper 8 (control+compat)
  * debian/copyright: several DEP5 fixes

 -- Andreas Tille <tille@debian.org>  Fri, 11 Nov 2011 11:46:22 +0100

arb (5.2-1) unstable; urgency=low

  * New upstream version
  * Standards-Version: 3.9.1 (no changes needed)
  * New debconf translations
    - Vietnamese (thanks to Clytie Siddall <clytie@riverland.net.au>)
      Closes: #576020
    - Danish (thanks to Joe Dalton <joedalton2@yahoo.dk>)
      Closes: #584283
    - Brazilian Portuguese (thanks to Gustavo Jordan
      <gustavojcbrasil@gmail.com>)
      Closes: #596647
  * Drop xview-clients Suggests in debian/control and replace any occurence
    of textedit (which is part of xview-clients) by editor via
    debian/patches/no_xview_dependency.patch
    Closes: 612534
  * debian/patches/20_Makefiles: clean up some errors in clean target
  * debian/patches/20_config.makefiles: Really get the DEB_BUILD_ARCH_BITS
    applied
  * Build-Depends: time

 -- Andreas Tille <tille@debian.org>  Wed, 09 Feb 2011 16:56:15 +0100

arb (5.1-1) unstable; urgency=low

  [ Andreas Tille ]
  * New upstream version
    Closes: #522021
  * debian/control:
    - Package arb-doc in non-free/doc
    - Standards-Version: 3.8.4 (Added README.source)
    - Build-Depends: dpkg-dev (>= 1.15.4) to make use of
      `dpkg-architecture -qDEB_BUILD_ARCH_BITS` in Makefile
    - Build-Depends: xutils-dev
    - arb Recommends: bioperl
    - arb Suggests: phyml
    - Build-Depends: openjdk-6-jdk instead of kaffe which might be subject
      of removal from Debian in the near future
  * Removed / changed patches which were applied upstream
    - debian/patches/ARB_release200712_gcc4.3.1.patch removed
    - debian/patches/20_replace_rxp_by_xmllint.patch removed
    - debian/patches/tmpfile_CVE-2008-5378.patch removed applied part
  * debian/{rules,*.install}: Cleanup regarding changes in new upstream version
  * debian/arb.README.debian:
    - Removed useless warning about prereleases
    - Added hint about different phyml versions
  * debian/patches/10_gcc_4.4.3.patch: compile with gcc-4.4.3
  * debian/rules: Add ARBHOME variable explicitly to clean target
  * Added Finish debconf translation (Thanks to Esko Arajärvi <edu@iki.fi>)
    Closes: #536516
  * Added Galician debconf translation (Thanks to marce
    <mvillarino@gmail.com>)
    Closes: #537534
  * Added Japanese debconf translation (Thankse to Hideki Yamane
    <henrich@debian.or.jp>)
    Closes: #554882
  * Added: Spanish debconf translation (Thanks to Francisco Javier Cuadrado
    <fcocuadrado@gmail.com>)
    Closes: #573005
  * Switch to source format 3.0

  [ David Paleino ]
  * Removed myself from Uploaders
  * New watch file

 -- Andreas Tille <tille@debian.org>  Tue, 23 Mar 2010 14:37:30 +0100

arb (0.0.20071207.1-7) unstable; urgency=low

  * Bumped debhelper to version 7
     -> dh_clean -k -> dh_clean; dh_prep
  * Standards-Version: 3.8.1 (no changes needed)
  * Enhanced package description of arb-common and arb-doc
    Closes: #517710
  * Added Portuguese translation for debconf messages (thanks to


=== debian/control ===
Source: arb
Section: non-free/science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Andreas Tille <tille@debian.org>
Build-Depends: chrpath,
               debhelper (>= 9),
               dpkg-dev (>= 1.15.4),
               freeglut3-dev | libglu-dev,
               libbio-perl-perl,
               libglew-dev,
               libglw1-mesa-dev,
               libmotif-dev,
               libpng-dev,
               libtiff4-dev,
               libxaw7-dev,
               libxml2-utils,
               libxpm-dev,
               lynx,
               time,
               openjdk-6-jdk | default-jdk,
               perl-doc,
               xsltproc,
               xutils-dev
Standards-Version: 3.9.3
Homepage: http://www.arb-home.de/
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/arb/trunk/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/arb/trunk/
XS-Autobuild: yes

Package: arb
Architecture: any
Depends: arb-common (= ${source:Version}),
         fastdnaml (>= 1.2.2-4),
         libarb (= ${binary:Version}),
         openssh-client,
         phylip (>= 3.6b),
         readseq (>= 1-1),
         transfig,
         tree-puzzle (>=5.0-3),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: bioperl, xfig
Suggests: arb-database, gnuplot, gv, phyml
Description: Integrated package for sequence database handling and analysis
 The ARB software is a graphically oriented package comprising various tools
 for sequence database handling and data analysis. A central database of
 processed (aligned) sequences and any type of additional data linked to the
 respective sequence entries is structured according to phylogeny or other
 user defined criteria.
 .
 The ARB project (latin, "arbor"=tree) is a joint initiative of the Lehrstuhl
 fuer Mikrobiologie http://www.mikro.biologie.tu-muenchen.de/ and the
 Lehrstuhl fuer Rechnertechnik und Rechnerorganisation
 http://wwwbode.informatik.tu-muenchen.de/ of the Technical University
 of Munich.

Package: libarb
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: arb
Description: Integrated package for sequence database handling and analysis
 The ARB software is a graphically oriented package comprising various tools
 for sequence database handling and data analysis. A central database of
 processed (aligned) sequences and any type of additional data linked to the
 respective sequence entries is structured according to phylogeny or other
 user defined criteria.
 .
 The ARB project (latin, "arbor"=tree) is a joint initiative of the Lehrstuhl
 fuer Mikrobiologie http://www.mikro.biologie.tu-muenchen.de/ and the
 Lehrstuhl fuer Rechnertechnik und Rechnerorganisation
 http://wwwbode.informatik.tu-muenchen.de/ of the Technical University
 of Munich.
 .
 This package contains the dynamic libraries which are used by arb.

Package: arb-common
Architecture: all
Depends: adduser,
         arb-doc (= ${source:Version}),
         ghostscript | postscript-preview,
         gv | postscript-viewer,
         perl-modules,
         ${misc:Depends},
         ${perl:Depends}
Recommends: arb
Description: Integrated package for sequence database handling and analysis
 The ARB software is a graphically oriented package comprising various tools
 for sequence database handling and data analysis. A central database of
 processed (aligned) sequences and any type of additional data linked to the
 respective sequence entries is structured according to phylogeny or other
 user defined criteria.
 .
 This package contains the architecture independent scripts of Arb.

Package: arb-doc
Architecture: all
Section: non-free/doc
Depends: ghostscript | postscript-preview,
         gv | postscript-viewer,
         ${misc:Depends}
Suggests: arb
Description: Integrated package for sequence database handling and analysis
 The ARB software is a graphically oriented package comprising various tools
 for sequence database handling and data analysis. A central database of
 processed (aligned) sequences and any type of additional data linked to the
 respective sequence entries is structured according to phylogeny or other
 user defined criteria.
 .
 This package contains the documentation for the package arb.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for arb using quilt

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
pkgcom=$(pkg)-common
pkgdoc=$(pkg)-doc
common=debian/$(pkgcom)

ARBHOME=$(CURDIR)

BITARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH_BITS)
ifeq ($(BITARCH),64)
    ARB_64:=1
else
    ARB_64:=0
endif

%:
	dh $@

override_dh_auto_build:
	mkdir -p LIBLINK MAKEBIN lib/help
	export LC_ALL=C ; \
	export PATH=$(ARBHOME)/bin:$${PATH} ; \
	export LD_LIBRARY_PATH=$(ARBHOME)/lib:$${LD_LIBRARY_PATH}; \
	  $(MAKE) DEBIAN=1 ARBHOME=$(ARBHOME) ARB_64=$(ARB_64) \
	  CPPFLAGS="$(CPPFLAGS)" CFLAGS="$(CFLAGS)" CXXFLAGS="$(CXXFLAGS)" LDFLAGS="$(LDFLAGS)" \
	  all ; \
	export LD_LIBRARY_PATH=$(ARBHOME)/lib:$${LD_LIBRARY_PATH}; \
	  $(MAKE) DEBIAN=1 ARBHOME=$(ARBHOME) ARB_64=$(ARB_64) \
	  CPPFLAGS="$(CPPFLAGS)" CFLAGS="$(CFLAGS)" CXXFLAGS="$(CXXFLAGS)" LDFLAGS="$(LDFLAGS)" \
	  arbxtras
	export LD_LIBRARY_PATH=$(ARBHOME)/lib:$${LD_LIBRARY_PATH}; \
	  cd HELP_SOURCE; $(MAKE) ARBHOME=$(ARBHOME) html

# Remove links inside these directories because Makefile does not really clean
# these directories
DIRSTOREMOVELINKS=AWT ARBDBS ARBDB2 EDIT4 LIBLINK MAKEBIN NALIGNER NAMES_COM ORS_COM PROBE PROBE_COM PROBE_SERVER TOOLS bin lib/inputMasks lib/help
# The following subdirectorys where created at compile time in some directories
# but will not be removed by clean target
SUBDIRSTOREMOVE=GENC GENH O
# Sometimes clean target does not work as expected.  Try to clean some dirs manually
DIRSTOCLEAN=AISC AISC_MKPTPS SOURCE_TOOLS

RemoveFromSourceAndBuild=PERL2ARB/Makefile PERL2ARB/ARB.c HELP_SOURCE/date.xsl \
                         lib/arb_tcp.dat lib/ARB.pm \
			 *.last_gcc TEMPLATES/arb_build.h \
			 GDE/MOLPHY/prot_tml.h \
			 PERL2ARB/perlmain.c \
			 PERL2ARB/ARB.bs PERL_SCRIPTS/test/test.stamp PERL2ARB/MYMETA.yml
FILESTOREMOVE=libXm.so.3 NALIGNER/NALIGNER.com lib/nas/names.dat $(RemoveFromSourceAndBuild)
DIRSTOREMOVE=INCLUDE HELP_SOURCE/Xml lib/help lib/help_html PERL5 lib/perl5 PROBE_SERVER/bin PERL2ARB/blib/man3 PROBE_SET/bin
DirsToKeepOnlyMAKEFILE=bin

override_dh_auto_clean:
	# Make does only work if config.makefile exists which is only the
	# case when quilt has installed the patches.  So there is neither
	# a need nor the expection of success if config.makefile is missing
	[ ! -f config.makefile ] || $(MAKE) DEBIAN=1 ARBHOME=$(ARBHOME) clean
	
	# fix broken clean process
	find . -type f -name "*.a"  -delete
	find . -type f -name "*.o"  -delete
	find . -type f -name "*.so" -delete
	rm -f `find bin -name "arb*" | grep -v ".pl$$"`
	rm -f `find $(DIRSTOREMOVELINKS) -type l`
	rm -f `find . -type f -name ".depends"`
	for dir in $(SUBDIRSTOREMOVE) ; do \
	   rm -rf `find . -name $${dir} -type d` ; \
	done
	rm -f `find $(DirsToKeepOnlyMAKEFILE) -maxdepth 1 -type f | grep -v Makefile`
	rm -f `find PROBE_WEB/CLIENT -name \*.class -type f`
	rm -f `find PROBE_WEB/CLIENT -name \*.jar -type f`
	rm -f $(FILESTOREMOVE)
	rm -fr $(DIRSTOREMOVE)
	for dtc in $(DIRSTOCLEAN); do if [ -d $${dtc} ] ; then cd $${dtc}; make clean ; fi; done
	find . -name "*.stamp" -o -name "*.bs" -o -name ".exists" -delete

override_dh_install:
	dh_install
	# remove files from arb package which are in arb-nas
	if [ -s debian/arb-nas.install ] ; then \
	    for arbfile in `sed 's?^bin/\([^[:space:]]\+\)[[:space:]]\+\(.\+\)?debian/$(pkg)/\2/\1?' debian/arb-nas.install | grep debian/$(arb)` ; do \
		rm -f $${arbfile} ; \
	    done ; \
	fi

	# the check is needed to make sure it will not fail when doing binary-arch only builds
	if [ -e debian/$(pkgcom)/usr/lib/arb/SH/arb_create_debian_conffile ] ; then \
	    # Move SH/README to docs \
	    cp -a SH/README debian/$(pkgcom)/usr/share/doc/arb/README_SH ; \
	    # Fix permission of scripts \
	    chmod a+x debian/$(pkgcom)/usr/lib/arb/SH/arb_create_debian_conffile ; \
	    chmod a+x debian/$(pkgcom)/usr/lib/arb/lib/macro.head ; \
	fi

	# Man page is not really needed and throws just a lintian warning
	# mkdir `pwd`/debian/$(pkg)/usr/share/man/man3
	# perldoc PERL2ARB/ARB.pm > `pwd`/debian/$(pkg)/usr/share/man/man3/ARB.3pm


override_dh_strip:
	# Fix rpath issue (once libarb is installed)
	if [ -e debian/libarb/usr/lib/arb/lib/ARB.so ] ; then \
	    chrpath --delete debian/libarb/usr/lib/arb/lib/ARB.so ; \
	fi
	dh_strip

override_dh_shlibdeps:
	dh_shlibdeps -a -l debian/libarb/usr/lib

# To update po files as recommended in po-debconf(7) 
debian/po/templates.pot: debian/arb-common.templates
	@debconf-updatepo
